"use strict";
var __extends = (this && this.__extends) || (function () {
    var extendStatics = function (d, b) {
        extendStatics = Object.setPrototypeOf ||
            ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
            function (d, b) { for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p]; };
        return extendStatics(d, b);
    };
    return function (d, b) {
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
Object.defineProperty(exports, "__esModule", { value: true });
var AssertionError = /** @class */ (function (_super) {
    __extends(AssertionError, _super);
    function AssertionError(message, expected, actual) {
        var _this = _super.call(this, message) || this;
        overridePrototype(_this, AssertionError.prototype);
        _this.expected = expected;
        _this.actual = actual;
        try {
            var stackLines = _this.stack.split('\n');
            var cutIndex_1 = -Infinity;
            for (var i = stackLines.length - 1; i >= 0; i -= 1) {
                if (/\s+at Expect/.test(stackLines[i])) {
                    cutIndex_1 = i;
                    break;
                }
            }
            _this.stack = stackLines.filter(function (line, index) {
                return !/\s+at/.test(line) || index > cutIndex_1;
            }).join('\n');
        }
        catch (e) {
            // Stack manipulation may fail
        }
        return _this;
    }
    return AssertionError;
}(Error));
exports.AssertionError = AssertionError;
AssertionError.prototype.name = 'AssertionError';
function overridePrototype(instance, to) {
    if (Object.setPrototypeOf) {
        Object.setPrototypeOf(instance, to);
    }
    else {
        instance.__proto__ = to;
    }
}
