import { Validator, AsyncValidator } from './validators/validateSatisfy';
export declare function expect(value: any): Expect;
declare class Expect {
    private value;
    private negated;
    constructor(value: any);
    readonly not: this;
    toEqual(expected: any): void;
    toStrictlyEqual(expected: any): void;
    toBeInstanceOf(constructor: Function): void;
    toHaveTypeOf(type: string): void;
    toBeTruthy(): void;
    toBeFalsy(): void;
    toBeGreaterThan(value: number): void;
    toBeGreaterThanOrEqual(value: number): void;
    toBeLessThan(value: number): void;
    toBeLessThanOrEqual(value: number): void;
    toBeCloseTo(value: number, precision?: number): void;
    toHaveProperty(path: string, expected?: any): void;
    toBeCalled(): void;
    toBeCalledTimes(count: number): void;
    toSatisfy(fn: Validator): void;
    toSatisfy(fn: AsyncValidator): Promise<void>;
}
export {};
