interface MockFunction {
    (...args: any[]): any;
    calls: any[][];
    returns(value: any): this;
    returnsOnce(value: any): this;
    throws(error?: any): this;
    throwsOnce(error?: any): this;
    resolves(value?: any): this;
    resolvesOnce(value?: any): this;
    rejects(error?: any): this;
    rejectsOnce(error?: any): this;
}
export declare function mockFn(implementation?: Function): MockFunction;
export declare function isMockFunction(value: unknown): value is MockFunction;
export {};
